<template>
  <Loading v-if="$fetchState.pending && !$fetchState.error"></Loading>
  <Error v-else-if="$fetchState.error" :error="$fetchState.error"></Error>
  <div v-else class="row">
    <b-col v-if="!dataLoaded" md="3" class="pr-3"></b-col>
    <template v-else>
      <template v-if="outputReport.uri">
        <OutputsCardReport :output-report="outputReport" />
      </template>
      <template v-else>
        <b-col md="3" class="pr-3">
          <div class="nav-project-outputs">
            <div class="d-none d-sm-inline-block w-100">
              <div class="subheader mb-2">{{ displayedJobsTitle }}</div>
              <div class="row">
                <div class="col">
                  <template v-if="!displayedJobs || !displayedJobs.length">
                    <div class="empty empty-bordered no-project-outputs">
                      <div class="empty-img-sm">
                        <img
                          src="/illustrations/no-outputs-history-grey.svg"
                          alt=""
                          height="128"
                        />
                      </div>
                      <p class="empty-subtitle text-muted">
                        There is no an output history yet
                      </p>
                    </div>
                  </template>
                  <OutputHistoryTable v-else :jobs="displayedJobs" />
                </div>
              </div>
            </div>
          </div>
        </b-col>
        <b-col sm="12" md="9">
          <template v-if="!displayedJobs || !displayedJobs.length">
            <div class="card-prj-outputs-deck row row-deck h-100">
              <div class="card-prj-outputs col-12 h-100">
                <div class="empty empty-bordered w-100">
                  <div class="empty-img-lg">
                    <img
                      src="/illustrations/no-outputs-to-show.svg"
                      alt=""
                      height="128"
                    />
                  </div>
                  <p class="empty-title">There are no outputs to show</p>
                  <p class="empty-subtitle text-muted">
                    Try configuring and executing a scenario
                  </p>
                </div>
              </div>
            </div>
          </template>
          <OutputsCardDeck
            :jobs="displayedJobs"
            :component-to-show="componentToShow"
          />
        </b-col>
      </template>
    </template>
  </div>
</template>
<script>
const displayedStates = ['finished'];

const jobStateFilter = (job) => {
  return job.state && displayedStates.includes(job.state.slug);
};

const executionDatetimeSort = (j1, j2) => {
  if (j1.execution_datetime < j2.execution_datetime) {
    return 1;
  } else if (j1.execution_datetime > j2.execution_datetime) {
    return -1;
  } else {
    return 0;
  }
};

export default {
  props: {
    componentToShow: {
      type: String,
      default: 'OutputsCard',
    },
    displayedJobsTitle: {
      type: String,
      default: 'Outputs History',
    },
  },
  data() {
    return {
      id: this.$nuxt.$route.params.id,
    };
  },
  async fetch() {
    const id = this.$nuxt.$route.params.id;
    const store = this.$nuxt.context.store;
    await store.dispatch('scenarios/fetchProjectScenarios', {
      projectId: id,
    });
    await store.dispatch('projects/fetchSingleProject', { id });
  },
  head() {
    return {
      title: 'Projects - RISIS Workspace',
    };
  },
  computed: {
    dataLoaded() {
      return !!this.project;
    },
    project() {
      return this.$store.getters['projects/singleProject'](this.id);
    },
    displayedJobs() {
      return this.project.jobs
        .filter(jobStateFilter)
        .sort(executionDatetimeSort);
    },
    outputReport() {
      return this.$store.getters['ui/outputReport'];
    },
    activeJob() {
      return this.$nuxt.context.store.getters['ui/activeJob'].id;
    },
  },
  mounted() {
    this.$store.commit('ui/setSearchWorkspaceVisible', false);
    if (this.dataLoaded && this.project.jobs) {
      const readyJobs = this.displayedJobs;
      if (
        readyJobs.length &&
        !readyJobs.map((job) => job.id).includes(this.activeJob)
      ) {
        const id = readyJobs[0].id;
        this.$nuxt.context.store.dispatch('ui/setActiveJob', {
          newActiveJob: { id },
        });
        this.$nuxt.context.store.dispatch('parameters/loadParameters', {
          projectId: this.$nuxt.$route.params.id,
          scenarioId: readyJobs.find((job) => job.id === id).scenario.id,
        });
      }
    }
  },
};
</script>
